Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# TextAssembler Class Reference

This class is not normally used directly by user code, but is used by the TextNode to lay out a block of text and convert it into rows of Geoms according to the TextProperties. More...

List of all members.

## Public Member Functions
| TextAssembler (TextAssembler const copy)
| TextAssembler (TextEncoder encoder)
PandaNode | assembleText ()
| Actually assembles all of the text into a GeomNode, and returns the node (or possibly a parent of the node, to keep the shadow separate).
int | calcC (int n)
| Computes the column index of the nth character or graphic object in the text and returns it.
int | calcIndex (int r, int c)
| Computes the character index of the character at the rth row and cth column position.
int | calcR (int n)
| Computes the row index of the nth character or graphic object in the text and returns it.
| clear ()
| Reinitializes the contents of the TextAssembler.
wchar_t | getCharacter (int n)
| Returns the character at the indicated position in the pre-wordwrapped string.
wchar_t | getCharacter (int r, int c)
| Returns the character at the indicated position in the indicated row.
bool | getDynamicMerge ()
| Returns the dynamic_merge flag.
TextGraphic const | getGraphic (int n)
| Returns the graphic object at the indicated position in the pre-wordwrapped string.
TextGraphic const | getGraphic (int r, int c)
| Returns the graphic object at the indicated position in the indicated row.
Vec2 const | getLr ()
| Returns the lower-right corner of the assembled text, in 2-d text coordinates.
int | getMaxRows ()
| If max_rows is greater than zero, no more than max_rows will be accepted.
bool | getMultilineMode ()
| Returns the multline_mode flag.
int | getNumCharacters ()
| Returns the number of characters of text, before wordwrapping.
int | getNumCols (int r)
| Returns the number of characters and/or graphic objects in the nth row.
int | getNumRows ()
| Returns the number of rows of text after it has all been wordwrapped and assembled.
string | getPlainWtext ()
| Returns a wstring that represents the contents of the text, without any embedded properties characters.
TextProperties const | getProperties (int r, int c)
| Returns the TextProperties in effect for the object at the indicated position in the indicated row.
TextProperties const | getProperties ()
| Returns the default TextProperties that are applied to the text in the absence of any nested property change sequences.
TextProperties const | getProperties (int n)
| Returns the TextProperties in effect for the object at the indicated position in the pre-wordwrapped string.
Vec2 const | getUl ()
| Returns the upper-left corner of the assembled text, in 2-d text coordinates.
UsageHint | getUsageHint ()
| Returns the UsageHint that will be applied to generated geometry.
float | getWidth (int n)
| Returns the width of the character or object at the indicated position in the pre-wordwrapped string.
float | getWidth (int r, int c)
| Returns the width of the character or object at the indicated position in the indicated row.
string | getWordwrappedPlainWtext ()
| Returns a wstring that represents the contents of the text, with newlines inserted according to the wordwrapping.
string | getWordwrappedWtext ()
| Returns a wstring that represents the contents of the text, with newlines inserted according to the wordwrapping.
string | getWtext ()
| Returns a wstring that represents the contents of the text.
float | getXpos (int r, int c)
| Returns the x position of the origin of the character or graphic object at the indicated position in the indicated row.
float | getYpos (int r, int c)
| Returns the y position of the origin of all of the characters or graphic objects in the indicated row.
TextAssembler | operator= (TextAssembler const copy)
| setDynamicMerge (bool dynamic_merge)
| Sets the dynamic_merge flag.
| setMaxRows (int max_rows)
| If max_rows is greater than zero, no more than max_rows will be accepted.
| setMultilineMode (bool flag)
| Sets the multiline mode flag.
| setProperties (TextProperties const properties)
| Specifies the default TextProperties that are applied to the text in the absence of any nested property change sequences.
| setUsageHint (UsageHint usage_hint)
| Specifies the UsageHint that will be applied to generated geometry.
bool | setWsubstr (string wtext, int start, int count)
| Replaces the 'count' characters from 'start' of the current text with the indicated replacement text.
bool | setWtext (string wtext)
| Accepts a new text string and associated properties structure, and precomputes the wordwrapping layout appropriately.
## Static Public Member Functions
static float | calcWidth (TextGraphic const graphic, TextProperties const properties)
| Returns the width of a single TextGraphic image.
static float | calcWidth (wchar_t character, TextProperties const properties)
| Returns the width of a single character, according to its associated font.
static bool | hasCharacter (wchar_t character, TextProperties const properties)
| Returns true if the named character exists in the font or can be synthesized by Panda, false otherwise.
static bool | hasExactCharacter (wchar_t character, TextProperties const properties)
| Returns true if the named character exists in the font exactly as named, false otherwise.
static bool | isWhitespace (wchar_t character, TextProperties const properties)
| Returns true if the indicated character represents whitespace in the font, or false if anything visible will be rendered for it.

## Detailed Description

This class is not normally used directly by user code, but is used by the TextNode to lay out a block of text and convert it into rows of Geoms according to the TextProperties.

However, user code may take advantage of it, if desired, for very low-level text operations.

## Constructor & Destructor Documentation

TextAssembler | ( | TextAssembler const | copy | ) |

TextAssembler | ( | TextEncoder | encoder | ) |

## Member Function Documentation

PandaNode assembleText | ( |  | ) |

Actually assembles all of the text into a GeomNode, and returns the node (or possibly a parent of the node, to keep the shadow separate).

Once this has been called, you may query the extents of the text via get_ul(), get_lr().

int calcC | ( | int | n | ) |

Computes the column index of the nth character or graphic object in the text and returns it.

If the nth character is not a normal printable character with a position in the wordwrapped string, returns -1 (for instance, a soft-hyphen character, or a newline character, may not have a corresponding position).

int calcIndex | ( | int | r,
|  | int | c
| ) |  |

Computes the character index of the character at the rth row and cth column position.

This is the inverse of calc_r_c().

It is legal for c to exceed the index number of the last column by 1, and it is legal for r to exceed the index number of the last row by 1, if c is 0.

int calcR | ( | int | n | ) |

Computes the row index of the nth character or graphic object in the text and returns it.

If the nth character is not a normal printable character with a position in the wordwrapped string, returns -1 (for instance, a soft-hyphen character, or a newline character, may not have a corresponding position).

static float calcWidth | ( | TextGraphic const | graphic,
|  | TextProperties const | properties
| ) |  | `[static]`

Returns the width of a single TextGraphic image.

static float calcWidth | ( | wchar_t | character,
|  | TextProperties const | properties
| ) |  | `[static]`

Returns the width of a single character, according to its associated font.

This also correctly calculates the width of cheesy ligatures and accented characters, which may not exist in the font as such.

clear | ( |  | ) |

Reinitializes the contents of the TextAssembler.

wchar_t getCharacter | ( | int | n | ) |

Returns the character at the indicated position in the pre-wordwrapped string.

If the object at this position is a graphic object instead of a character, returns 0.

wchar_t getCharacter | ( | int | r,
|  | int | c
| ) |  |

Returns the character at the indicated position in the indicated row.

If the object at this position is a graphic object instead of a character, returns 0.

bool getDynamicMerge | ( |  | ) |

Returns the dynamic_merge flag.

See TextNode.set_flatten_flags().

TextGraphic const getGraphic | ( | int | n | ) |

Returns the graphic object at the indicated position in the pre-wordwrapped string.

If the object at this position is a character instead of a graphic object, returns NULL.

TextGraphic const getGraphic | ( | int | r,
|  | int | c
| ) |  |

Returns the graphic object at the indicated position in the indicated row.

If the object at this position is a character instead of a graphic object, returns NULL.

Vec2 const getLr | ( |  | ) |

Returns the lower-right corner of the assembled text, in 2-d text coordinates.

int getMaxRows | ( |  | ) |

If max_rows is greater than zero, no more than max_rows will be accepted.

Text beyond that will be truncated.

bool getMultilineMode | ( |  | ) |

Returns the multline_mode flag.

See TextNode.set_multiline_mode().

int getNumCharacters | ( |  | ) |

Returns the number of characters of text, before wordwrapping.

int getNumCols | ( | int | r | ) |

Returns the number of characters and/or graphic objects in the nth row.

int getNumRows | ( |  | ) |

Returns the number of rows of text after it has all been wordwrapped and assembled.

string getPlainWtext | ( |  | ) |

Returns a wstring that represents the contents of the text, without any embedded properties characters.

If there is an embedded graphic object, a zero value is inserted in that position.

This string has the same length as get_num_characters(), and the characters in this string correspond one-to-one with the characters returned by get_character(n).

TextProperties const getProperties | ( |  | ) |

Returns the default TextProperties that are applied to the text in the absence of any nested property change sequences.

TextProperties const getProperties | ( | int | n | ) |

Returns the TextProperties in effect for the object at the indicated position in the pre-wordwrapped string.

TextProperties const getProperties | ( | int | r,
|  | int | c
| ) |  |

Returns the TextProperties in effect for the object at the indicated position in the indicated row.

Vec2 const getUl | ( |  | ) |

Returns the upper-left corner of the assembled text, in 2-d text coordinates.

UsageHint getUsageHint | ( |  | ) |

Returns the UsageHint that will be applied to generated geometry.

See set_usage_hint().

float getWidth | ( | int | n | ) |

Returns the width of the character or object at the indicated position in the pre-wordwrapped string.

float getWidth | ( | int | r,
|  | int | c
| ) |  |

Returns the width of the character or object at the indicated position in the indicated row.

string getWordwrappedPlainWtext | ( |  | ) |

Returns a wstring that represents the contents of the text, with newlines inserted according to the wordwrapping.

The string will contain no embedded properties characters. If there is an embedded graphic object, a zero value is inserted in that position.

This string has the same number of newline characters as get_num_rows(), and the characters in this string correspond one-to-one with the characters returned by get_character(r, c).

string getWordwrappedWtext | ( |  | ) |

Returns a wstring that represents the contents of the text, with newlines inserted according to the wordwrapping.

The string will contain embedded properties characters, which may not exactly match the embedded properties characters of the original string, but it will encode the same way.

Embedded properties characters will be closed before every newline, then reopened (if necessary) on the subsequent character following the newline. This means it will be safe to divide the text up at the newline characters and treat each line as an independent piece.

string getWtext | ( |  | ) |

Returns a wstring that represents the contents of the text.

The string will contain embedded properties characters, which may not exactly match the embedded properties characters of the original string, but it will encode the same way.

float getXpos | ( | int | r,
|  | int | c
| ) |  |

Returns the x position of the origin of the character or graphic object at the indicated position in the indicated row.

It is legal for c to exceed the index number of the last column by 1, and it is legal for r to exceed the index number of the last row by 1, if c is 0.

float getYpos | ( | int | r,
|  | int | c
| ) |  |

Returns the y position of the origin of all of the characters or graphic objects in the indicated row.

It is legal for r to exceed the index number of the last row by 1. The value of c is presently ignored.

static bool hasCharacter | ( | wchar_t | character,
|  | TextProperties const | properties
| ) |  | `[static]`

Returns true if the named character exists in the font or can be synthesized by Panda, false otherwise.

(Panda can synthesize some accented characters by combining similar-looking glyphs from the font.)

This returns true for whitespace and Unicode whitespace characters (if they exist in the font), but returns false for characters that would render with the "invalid glyph".

static bool hasExactCharacter | ( | wchar_t | character,
|  | TextProperties const | properties
| ) |  | `[static]`

Returns true if the named character exists in the font exactly as named, false otherwise.

Note that because Panda can assemble glyphs together automatically using cheesy accent marks, this is not a reliable indicator of whether a suitable glyph can be rendered for the character. For that, use has_character() instead.

This returns true for whitespace and Unicode whitespace characters (if they exist in the font), but returns false for characters that would render with the "invalid glyph". It also returns false for characters that would be synthesized within Panda, but see has_character().

static bool isWhitespace | ( | wchar_t | character,
|  | TextProperties const | properties
| ) |  | `[static]`

Returns true if the indicated character represents whitespace in the font, or false if anything visible will be rendered for it.

This returns true for whitespace and Unicode whitespace characters (if they exist in the font), and returns false for any other characters, including characters that do not exist in the font (these would be rendered with the "invalid glyph", which is visible).

Note that this function can be reliably used to identify Unicode whitespace characters only if the font has all of the whitespace characters defined. It will return false for any character not in the font, even if it is an official Unicode whitespace character.

TextAssembler operator= | ( | TextAssembler const | copy | ) |

setDynamicMerge | ( | bool | dynamic_merge | ) |

Sets the dynamic_merge flag.

See TextNode.set_flatten_flags().

setMaxRows | ( | int | max_rows | ) |

If max_rows is greater than zero, no more than max_rows will be accepted.

Text beyond that will be truncated.

Setting this will not truncate text immediately. You must follow this up with a call to set_wtext() to truncate the existing text.

setMultilineMode | ( | bool | flag | ) |

Sets the multiline mode flag.

Set the multiline mode to allow text to wrap. It defaults to true.

setProperties | ( | TextProperties const | properties | ) |

Specifies the default TextProperties that are applied to the text in the absence of any nested property change sequences.

setUsageHint | ( | UsageHint | usage_hint | ) |

Specifies the UsageHint that will be applied to generated geometry.

The default is UH_static, which is probably the right setting, but if you know the TextNode's geometry will have a short lifespan, it may be better to set it to UH_stream. See geomEnums.h.

bool setWsubstr | ( | string | wtext,
|  | int | start,
|  | int | count
| ) |  |

Replaces the 'count' characters from 'start' of the current text with the indicated replacement text.

If the replacement text does not have count characters, the length of the string will be changed accordingly.

The substring may include nested formatting characters, but they must be self-contained and self-closed. The formatting characters are not literally saved in the internal string; they are parsed at the time of the set_wsubstr() call.

The return value is true if all the text is accepted, or false if some was truncated (see set_max_rows()).

bool setWtext | ( | string | wtext | ) |

Accepts a new text string and associated properties structure, and precomputes the wordwrapping layout appropriately.

After this call, get_wordwrapped_wtext() and get_num_rows() can be called.

The return value is true if all the text is accepted, or false if some was truncated (see set_max_rows()).

All Classes Namespaces Functions Variables Enumerations Enumerator Properties